#ifndef	__READER_H__
#define	__READER_H__
#include "stdio.h"
#include "stdlib.h"
#include "stddef.h"
#include "stdarg.h"
#include "stdint.h"
#include "memory.h"
#include "string.h"
#include "errno.h"
#include "ctype.h"
#include "signal.h"
#include "unistd.h"
#include "getopt.h"
#include "time.h"
#include "fcntl.h"
#include "sys/stat.h"
#include "sys/types.h"
#include "sys/wait.h"
#include "sys/socket.h"
#include "netinet/in.h"
#include "netinet/ip.h"
#include "arpa/inet.h"

#define	DX_SERVER_START		1
#define	DX_SERVER_STOP		2

#define	DX_MAX_LINKS		8
#define	DX_MAX_FDS		32

#define	DX_WORK_BUFSZ		(2*1024*1024)

#define	DX_AGT_OPEN_FILE	101
#define	DX_AGT_CLOSE_FILE	102
#define	DX_AGT_READ_DATA	103

extern void dx_logfile_error(const char *fmt, ...);
extern void dx_close_logfile(void);

extern uint32_t dx_ntoh32(uint32_t n4);
extern uint64_t dx_ntoh64(uint64_t n8);
extern uint32_t dx_hton32(uint32_t h4);
extern uint64_t dx_hton64(uint64_t h8);

extern int dx_setsignals(void);
extern int dx_create_listener(char *ipaddr, int port);
extern int dx_accept_client(int sock);
extern int dx_recv_data(int sock, uint8_t *buf, int buf_sz);
extern int dx_send_data(int sock, uint8_t *buf, int dsz);
extern int dx_worker(int sock);

extern ssize_t pread(int fd, void *buf, size_t count, off_t offset);
#endif /* __READER_H__ */
