#include "reader.h"

extern volatile sig_atomic_t	x_stop_server;
extern pid_t	x_child[DX_MAX_LINKS];


static void dx_sigterm(int s)
{
    int	olderrno = errno;


    (void)s;

    x_stop_server = 1;
    errno = olderrno;
}

static void dx_sigchild(int s)
{
    int		i;
    int		olderrno = errno;
    pid_t	pid;


    (void)s;

    while ((pid = waitpid(-1, NULL, WNOHANG)) > 0) {
        /* clean child pid */
        for (i=0; i<DX_MAX_LINKS; i++) {
            if (x_child[i] == pid) {
                x_child[i] = -1;
                break;
            }
        }
    }

    errno = olderrno;
}

int dx_setsignals(void)
{
    int			i;
    sigset_t		sigs;
    struct sigaction	sa;


    for (i=1; i<32; i++) {
        signal(i, SIG_IGN);
    }

    sigfillset(&sigs);
    sigemptyset(&sa.sa_mask);

    sa.sa_flags   = 0;
    sa.sa_handler = dx_sigchild;
    sigdelset(&sigs, SIGCHLD);
    sigaction(SIGCHLD, &sa, NULL);

    sa.sa_handler = SIG_IGN;
    sigaction(SIGPIPE, &sa, NULL);
    sigaction(SIGALRM, &sa, NULL);
    sigaction(SIGINT, &sa, NULL);
    sigdelset(&sigs, SIGINT);

    sa.sa_flags   = 0;
    sa.sa_handler = dx_sigterm;
    sigdelset(&sigs, SIGTERM);
    sigaction(SIGTERM, &sa, NULL);
    sigdelset(&sigs, SIGQUIT);
    sigaction(SIGQUIT, &sa, NULL);

    sigprocmask(SIG_SETMASK, &sigs, NULL);

    return (0);
}

